package com.example.demo.config;

import lombok.extern.slf4j.Slf4j;
import org.apache.qpid.jms.JmsConnection;
import org.apache.qpid.jms.JmsConnectionListener;
import org.apache.qpid.jms.message.JmsInboundMessageDispatch;
import org.apache.tomcat.util.codec.binary.Base64;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;
import javax.jms.*;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import java.net.URI;
import java.util.Hashtable;

//@Configuration
@Slf4j
public class AmqpConfig {

    private String accessKey = "LTAI5t9DYVYpzxbmYBx3t4LU";

    private String accessSecret = "tM4EmXqeohWTxJ5R1AmsItai6zjiaQ";

    private String groupId = "DEFAULT_GROUP";

    private String clientId = "zyh";
    private String iotInstanceId = "iot-06z00hk8iq70r0s";
    private String host = "iot-06z00hk8iq70r0s.amqp.iothub.aliyuncs.com";

    @Bean
    public Session consumer() throws Exception {

        log.info("start...");

        String signMethod = "hmacsha1";

        long timeStamp = System.currentTimeMillis();
        //userName组装方法，请参见AMQP客户端接入说明文档。
        String userName = clientId + "|authMode=aksign"
                + ",signMethod=" + signMethod
                + ",timestamp=" + timeStamp
                + ",authId=" + accessKey
                + ",iotInstanceId=" + iotInstanceId
                + ",consumerGroupId=" + groupId
                + "|";
        log.info("username:{}",userName);
        //计算签名，password组装方法，请参见AMQP客户端接入说明文档。
        String signContent = "authId=" + accessKey + "&timestamp=" + timeStamp;
        String password = doSign(signContent, accessSecret, signMethod);
        String connectionUrl = "failover:(amqps://" + host + ":5671?amqp.idleTimeout=80000)"
                + "?failover.reconnectDelay=30";


        Hashtable<String, String> hashtable = new Hashtable<>();
        hashtable.put("connectionfactory.URL", connectionUrl);
        hashtable.put("queue.QUEUE", "default");
        hashtable.put("queue.ZYH", "default");
        hashtable.put(Context.INITIAL_CONTEXT_FACTORY, "org.apache.qpid.jms.jndi.JmsInitialContextFactory");

        Context context  = new InitialContext(hashtable);

        ConnectionFactory connectionFactory = (ConnectionFactory) context.lookup("URL");
        Destination queue = (Destination) context.lookup("QUEUE");

        Connection connection = connectionFactory.createConnection(userName,password);

        ((JmsConnection) connection).addConnectionListener(new ConnectListener());

        Session session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
        connection.start();

        MessageConsumer consumer = session.createConsumer(queue);

        consumer.setMessageListener(message -> {
            try {
                byte[] body = message.getBody(byte[].class);
                String content = new String(body);
                String topic = message.getStringProperty("topic");
                String messageId = message.getStringProperty("messageId");
                log.info("receive message"
                        + ",\n topic = " + topic
                        + ",\n messageId = " + messageId
                        + ",\n content = " + content);
            } catch (Exception e) {
                log.error("processMessage occurs error ", e);
            }
        });

        return session;

    }

    private static String doSign(String toSignString, String secret, String signMethod) throws Exception {
        SecretKeySpec signingKey = new SecretKeySpec(secret.getBytes(), signMethod);
        Mac mac = Mac.getInstance(signMethod);
        mac.init(signingKey);
        byte[] rawHmac = mac.doFinal(toSignString.getBytes());
        return Base64.encodeBase64String(rawHmac);
    }


}