package com.example.demo.config;

import lombok.extern.slf4j.Slf4j;
import org.apache.qpid.jms.JmsConnectionListener;
import org.apache.qpid.jms.message.JmsInboundMessageDispatch;

import javax.jms.MessageConsumer;
import javax.jms.MessageProducer;
import javax.jms.Session;
import java.net.URI;

@Slf4j
public class ConnectListener implements JmsConnectionListener {

    public ConnectListener() {
        log.info("ConnectListener init...");
    }

    @Override
    public void onConnectionEstablished(URI uri) {
        log.error("uri:{}",uri);
    }

    @Override
    public void onConnectionFailure(Throwable throwable) {
        throwable.printStackTrace();
    }

    @Override
    public void onConnectionInterrupted(URI uri) {
        log.error("uri:{}",uri);
    }

    @Override
    public void onConnectionRestored(URI uri) {
        log.error("uri:{}",uri);
    }

    @Override
    public void onInboundMessage(JmsInboundMessageDispatch jmsInboundMessageDispatch) {
        log.error("jmsInboundMessageDispatch:{}",jmsInboundMessageDispatch);
    }

    @Override
    public void onSessionClosed(Session session, Throwable throwable) {
        log.error("session:{}",throwable);
    }

    @Override
    public void onConsumerClosed(MessageConsumer messageConsumer, Throwable throwable) {
        log.error("messageConsumer:{}",throwable);
    }

    @Override
    public void onProducerClosed(MessageProducer messageProducer, Throwable throwable) {
        log.error("messageProducer:{}",throwable);
    }
}
