package com.example.demo.controller;

import cn.hutool.json.JSONUtil;
import com.aliyun.iot20180120.Client;
import com.aliyun.iot20180120.models.PubRequest;
import com.aliyun.iot20180120.models.PubResponse;
import com.example.demo.dto.VoiceData;
import io.netty.util.internal.ObjectUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.tomcat.util.codec.binary.Base64;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RestController;

import javax.jms.*;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import java.util.Hashtable;

@RestController
@Slf4j
public class IndexController {

    @Autowired
    private Client client;
    private Session session;

    private String iotInstanceId = "iot-06z00hk8iq70r0s";

    @GetMapping("/1")
    public void index() throws NamingException, JMSException {
        log.error("gogo");
        Hashtable<String, String> hashtable = new Hashtable<>();
        hashtable.put("queue.QUEUE", "default");
        hashtable.put("queue.ZYH", "default");
        hashtable.put(Context.INITIAL_CONTEXT_FACTORY, "org.apache.qpid.jms.jndi.JmsInitialContextFactory");

        Context context  = new InitialContext(hashtable);
        Destination prod = (Destination) context.lookup("ZYH");

        MessageProducer prodocer = session.createProducer(prod);

        prodocer.send(session.createTextMessage("sssss"));
        log.error("bye.");
    }

    // http://localhost:8082/msg/zsw38/真的食物/get
    @GetMapping("/msg/{device}/{content}/{volume}")
    public String index2(@PathVariable("device") String device,@PathVariable("content") String context,@PathVariable("volume") Integer volume) throws Exception {
        VoiceData voiceData = new VoiceData();
        voiceData.setContext(context);
        voiceData.setVolume(volume);

        String json = JSONUtil.toJsonStr(voiceData);

        String topic = "/hhlz49DDHhl/"+device+"/user/get";
        PubRequest pubRequest = new PubRequest();
        pubRequest.setIotInstanceId(iotInstanceId);
        pubRequest.setDeviceName(device);
        pubRequest.setMessageContent(Base64.encodeBase64String(json.getBytes()));
        pubRequest.setQos(0);
        pubRequest.setProductKey("hhlz49DDHhl");
        pubRequest.setTopicFullName(topic);
        PubResponse res = client.pub(pubRequest);
        log.info("device:{},context:{}",device,json);
//        log.info("body:{}",res.getBody());
//        log.info("status:{}",res.getStatusCode());
        return res.getBody().getMessageId();
    }
}
